#include<bits/stdc++.h>
using namespace std;
const int maxn = 5005;
int n,k;
int a[maxn];
int tree[maxn*4];
int dp[maxn][maxn];
void make_tree( int i, int l, int r )
{
    if( l == r )
    {
        tree[i] = ( 1 << a[l] );
        return;
    }

    int m = ( l + r ) / 2;

    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);

    tree[i] = ( tree[i*2] | tree[i*2+1] );
}
int query( int i, int l, int r, int ql, int qr )
{
    if( l == ql && r == qr ) return tree[i];
    int m = ( l + r ) / 2;

    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else return ( query(i*2,l,m,ql,m) | query(i*2+1,m+1,r,m+1,qr) );
}
void read()
{
    cin >> n >> k;
    for( int i = 1; i <= n; i ++ )
        cin >> a[i];
}
int get_cnt( int x )
{
    int cnt = 0;
    while( x != 0 )
    {
        if( x % 2 == 1 ) cnt += 1;
        x /= 2;
    }
    return cnt;
}
void solve()
{
    for( int i = 1; i <= k; i ++ )
    {
        for( int j = 1; j <= n; j ++ )
        {
            for( int l = i-1; l < j; l ++ )
            {
                int x = query(1,1,n,l+1,j);
                dp[i][j] = max( dp[i][j] , dp[i-1][l] + get_cnt(x) );
            }
        }
    }
    cout << dp[k][n] << endl;
}
int main()
{
    read();
    make_tree(1,1,n);
    solve();
    return 0;
}
