#include<bits/stdc++.h>
#define lli long long int
#define endl "\n"
using namespace std;
struct edge{
    lli l, p, f, t, ind; //lazy, price, from, to
    bool operator < (edge ed){
        if(l!=ed.l)return l<ed.l;
        if(p!=ed.p)return p>ed.p;
        if(f!=ed.f)return f<ed.f;
        if(t!=ed.t)return t<ed.t;
        return ind<ed.ind;
    }
};
vector<edge> v;
vector<lli> chosen;
const lli MAXN=2000005;
lli par[MAXN], sz[MAXN], N, M, a, b, c1, c2;
lli union_find(lli x){
    if(x==par[x])return x;
    return par[x]=union_find(par[x]);
}
bool mergev(lli x, lli y){
    lli rootx=union_find(x), rooty=union_find(y);
    if(rootx==rooty)return 0;
    if(sz[rootx]>sz[rooty]){
        par[rooty]=rootx;
        sz[rootx]+=sz[rooty];
    }else{
        par[rootx]=rooty;
        sz[rooty]+=sz[rootx];
    }
    return 1;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>M;
    for(lli i=1; i<=M; i++){
        cin>>a>>b>>c1>>c2;
        v.push_back({c1, c2, min(a, b), max(a, b), i});
    }
    sort(v.begin(), v.end());
    for(lli i=1; i<=N; i++){
        par[i]=i;
        sz[i]=1;
    }
    for(lli i=0; i<v.size(); i++){
        if(mergev(v[i].f, v[i].t)){
            chosen.push_back(v[i].ind);
        }
        if(chosen.size()==N-1)break;
    }
    for(lli i=0; i<chosen.size(); i++)cout<<chosen[i]<<endl;
    return 0;
}