#pragma GCC optimize ("Ofast")
#include<iostream>
#define endl "\n"
using namespace std;

int const MAXN=1e5+1;
long long inf = 1e18;
long long dp[MAXN][4], par_sum[MAXN];
int n, k, a[MAXN];

void fill_data()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=2;j<=k;j++)
        {
            dp[i][j] = inf;
        }
    }
}

long long cost(int l, int r)
{
    return (par_sum[r] - par_sum[l-1]) * (r-l);
}

void solve(int l, int r, int k, int optl, int optr)
{
    if(l > r) return;
    int mid = (l+r)/2, opt;
    for(int i=optl; i<=min(optr, mid);i++)
    {
        if(dp[i-1][k-1] + cost(i, mid) <= dp[mid][k])
        {
            dp[mid][k] = dp[i-1][k-1] + cost(i, mid);
            opt = i;
        }
    }
    solve(l, mid-1, k, optl, opt);
    solve(mid+1, r, k, opt, optr);
}

void read()
{
    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        par_sum[i] += par_sum[i-1] + a[i];
    }
    fill_data();
    for(int i=1;i<=n;i++)
    {
        dp[i][1] = cost(1, i);
    }
    for(int i=2;i<=k;i++)
    {
        solve(1,n,i,1,n);
    }
    cout<<dp[n][k]<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
