#include<bits/stdc++.h>
using namespace std;
const int maxn = 200002;
struct edge
{
    int x;
    int y;
    int a;
    int b;
    int num;
    edge(){};
    edge( int x1, int y1, int a1, int b1, int num1 )
    {
        x = x1;
        y = y1;
        a = a1;
        b = b1;
        num = num1;
    }
};
int n,m;
vector<edge>v;
int leader[maxn];
int rang[maxn];
void init_dsu()
{
    for( int i = 1; i <= n; i ++ )
    {
        leader[i] = i;
        rang[i] = 1;
    }
}
int find_leader( int w )
{
    if( leader[w] == w ) return w;
    leader[w] = find_leader( leader[w] );
    return leader[w];
}
bool is_connect( int ver1, int ver2 )
{
    int l1 = find_leader(ver1);
    int l2 = find_leader(ver2);
    if( l1 == l2 ) return 1;
    else return 0;
}
void dsu( int ver1, int ver2 )
{
    int l1 = find_leader(ver1);
    int l2 = find_leader(ver2);
    if( l1 == l2 ) return;
    if( rang[l1] < rang[l2] ) swap(l1,l2);
    rang[l1] += rang[l2];
    leader[l2] = l1;
}
bool cmp( edge e1, edge e2 )
{
    if( e1.a < e2.a ) return 1;
    else if( e1.a > e2.a ) return 0;
    else if( e1.b > e2.b ) return 1;
    else return 0;
}
void read()
{
    cin >> n >> m;
    for( int i = 1; i <= m; i ++ )
    {
        int from,to,c1,c2;
        cin >> from >> to >> c1 >> c2;
        edge e(from,to,c1,c2,i);
        v.push_back(e);
    }
    init_dsu();
    sort(v.begin(),v.end(),cmp);
    //for( int i = 0; i < m; i ++ )
        //cout << v[i].x << " " << v[i].y << " " << v[i].a << " " << v[i].b << endl;
}
void solve()
{
    int cnt = 0;
    for( int i = 0; i < m; i ++ )
    {
        if( cnt == n-1 ) break;
        int nb1 = v[i].x;
        int nb2 = v[i].y;
        if( is_connect(nb1,nb2) == 0 )
        {
            dsu(nb1,nb2);
            cnt += 1;
            cout << v[i].num << endl;
        }
    }
}
int main()
{
    read();
    solve();
    return 0;
}
