#include<bits/stdc++.h>
using namespace std;
const long long maxn = 200002;
struct edge
{
    long long x;
    long long y;
    long long a;
    long long b;
    long long num;
    edge(){};
    edge( long long x1, long long y1, long long a1, long long b1, long long num1 )
    {
        x = x1;
        y = y1;
        a = a1;
        b = b1;
        num = num1;
    }
};
long long n,m;
vector<edge>v;
long long leader[maxn];
long long rang[maxn];
void init_dsu()
{
    for( long long i = 1; i <= n; i ++ )
    {
        leader[i] = i;
        rang[i] = 1;
    }
}
long long find_leader( long long w )
{
    if( leader[w] == w ) return w;
    leader[w] = find_leader( leader[w] );
    return leader[w];
}
bool is_connect( long long ver1, long long ver2 )
{
    long long l1 = find_leader(ver1);
    long long l2 = find_leader(ver2);
    if( l1 == l2 ) return 1;
    else return 0;
}
void dsu( long long ver1, long long ver2 )
{
    long long l1 = find_leader(ver1);
    long long l2 = find_leader(ver2);
    if( l1 == l2 ) return;
    if( rang[l1] < rang[l2] ) swap(l1,l2);
    rang[l1] += rang[l2];
    leader[l2] = l1;
}
bool cmp( edge e1, edge e2 )
{
    if( e1.a < e2.a ) return 1;
    else if( e1.a > e2.a ) return 0;
    else if( e1.b > e2.b ) return 1;
    else return 0;
}
void read()
{
    cin >> n >> m;
    for( long long i = 1; i <= m; i ++ )
    {
        long long from,to,c1,c2;
        cin >> from >> to >> c1 >> c2;
        edge e(from,to,c1,c2,i);
        v.push_back(e);
    }
    init_dsu();
    sort(v.begin(),v.end(),cmp);
    //for( long long i = 0; i < m; i ++ )
        //cout << v[i].x << " " << v[i].y << " " << v[i].a << " " << v[i].b << endl;
}
void solve()
{
    long long cnt = 0;
    for( long long i = 0; i < m; i ++ )
    {
        if( cnt == n-1 ) break;
        long long nb1 = v[i].x;
        long long nb2 = v[i].y;
        if( is_connect(nb1,nb2) == 0 )
        {
            dsu(nb1,nb2);
            cnt += 1;
            cout << v[i].num << endl;
        }
    }
}
int main()
{
    read();
    solve();
    return 0;
}
