#include<bits/stdc++.h>
using namespace std;
const int maxn = 5005;
int n,k;
int a[maxn];
int tree[maxn*4];
int dp[maxn][maxn];
void make_tree( int i, int l, int r )
{
    if( l == r )
    {
        tree[i] = ( 1 << a[l] );
        return;
    }

    int m = ( l + r ) / 2;

    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);

    tree[i] = ( tree[i*2] | tree[i*2+1] );
}
int query( int i, int l, int r, int ql, int qr )
{
    if( l == ql && r == qr ) return tree[i];
    int m = ( l + r ) / 2;

    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else return ( query(i*2,l,m,ql,m) | query(i*2+1,m+1,r,m+1,qr) );
}
void read()
{
    cin >> n >> k;
    for( int i = 1; i <= n; i ++ )
        cin >> a[i];
}
int get_cnt( int x )
{
    int cnt = 0;
    while( x != 0 )
    {
        if( x % 2 == 1 ) cnt += 1;
        x /= 2;
    }
    return cnt;
}
void solve()
{
    int ans = 0;
    for( int i = 1; i < n; i ++ )
    {
        int x = query(1,1,n,1,i);
        int y = query(1,1,n,i+1,n);
        ans = max( get_cnt(x) + get_cnt(y) , ans );
    }
    cout << ans << endl;
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    make_tree(1,1,n);
    solve();
    return 0;
}
